## Paralax Scrolling Background
## Brendan SPeer

import random

from pyogre import ogre

class ParallaxBackgroundBuilds(object):
    def __init__(self, sMgr, met='BB_Building'):
        self.sMgr = sMgr
        
        self.bb = sMgr.createBillboardSet("BackBuild",20)
        self.bb.defaultWidth = 45
        self.bb.defaultHeight = 45
        self.bb.materialName = met
        self.bb.cullIndividually = True
    
        self.sMgr.rootSceneNode.attachObject(self.bb)


        mm = ogre.MaterialManager.getSingleton()
        skyMaterial = ogre.MaterialPointer(mm.create('SkyMat', 'General'))
        skyMaterial.lightingEnabled = False
        
        textureUnitState = skyMaterial.getTechnique(0).getPass(0).createTextureUnitState('RustedMetal.jpg', 0)
        textureUnitState.setScrollAnimation(0.25, 0)

        #self.sMgr.setSkyDome(True, 'SkyMat',-5,2)


        #spacing=150
        for j in range(17):
             self.crebb()
    
    
    def crebb(self):
        self.bb.createBillboard((175,-105 + random.randint(-10,10),random.randrange(-10,-140,-1))) 
    
    def update(self,dt = 500):
        for j in range(self.bb.getNumBillboards()):
            cb = self.bb.getBillboard(j)
            x, y, z = cb.position
            #print dt
            x += (((z + 550) * -0.0075) * dt * 180)
            if (x < -250):
                self.bb.removeBillboard(cb)
                self.crebb()
            else:
                cb.position = (x,y,z)

class ParallaxBackground(object):
    def __init__(self, sMgr):
        self.sMgr = sMgr
        
        self.builds = []
        self.builds.append(ParallaxBackgroundBuilds(sMgr))
        
        
    def update(self, dt=500):
        for x in self.builds:
            x.update(dt)