from pygame.time import get_ticks
import math
from util import *

def stop(self, dt):
    pass

def genWobble(amp=10, freq=1, phase=0):
    def wobble(self, dt):
        self.dy = amp*math.cos(phase+2*math.pi*freq*get_ticks()/1000)
    return wobble

def genOrbit(ship, r, speed):
    idle=genWobble()
    def orbit(enemy, dt):
        if ship.cloak == 1:
            enemy.dx = 0
            return idle(enemy,dt)
        a=speed**2/r
        c=tuple(ship.node.position)[:2]
        p=tuple(enemy.node.position)[:2]
        v1=sub(p,c)
        d=norm(v1)
        v3=add(scale(((-a+(r-d))*dt)/d,v1),scale(speed/d,rot(math.pi/2,v1)))
#        v3=scale(speed/norm(v2),v2)
        (enemy.dx,enemy.dy)=v3
    return orbit

